##############
# Exercise 1 #
##############
# Solution
1) Consider this specification:
   - calmodel = ~ x
   Which and how many population totals are involved?
# A1) Two totals
#     - population total of x
#     - total number of elementary units (because the intercept term has not
#       been removed).


2) Consider this specification:
   - calmodel = ~ A -1
   Which and how many population totals are involved?
# A2) kA totals, one for each category of A
#     - Total number of elementary units within domains defined by A.


3) Consider this specification:
   - calmodel = ~ ones -1
   Which and how many population totals are involved?
# A3) One total
#     - total number of elementary units for the whole population


4) Consider this specification:
   - calmodel = ~ A + B -1
   Which and how many population totals are involved?
# A4) kA + kB -1 totals (-1 because of collinearity)
#     - total number of elementary units within domains defined by A
#     - total number of elementary units within domains defined by B


5) Consider this specification:
   - calmodel = ~ A:B -1
   Which and how many population totals are involved? Is this calibration model
   factorizable? If yes, rephrase it in one (or many) equivalent partitioned form(s):
# A5) kA*kB totals (no collinearity, all two-way counts are independent)
#     - total number of elementary units within domains defined by crossing A
#       and B
#
#     Possible partitioned formulations:
#     - calmodel  = ~ A -1
#     - partition = ~ B
#
#     - calmodel  = ~ B -1
#     - partition = ~ A
#
#     - calmodel  = ~ ones -1
#     - partition = ~ A:B


6) Consider this specification:
   - calmodel = ~ (x + y):A + z -1
   Which and how many population totals are involved?
# A6) 2*kA + 1 totals
#     - total of x within domains defined by A
#     - total of y within domains defined by A
#     - total of z for the whole population
  
   
7) Consider the following specifications:
   - calmodel = ~ ones:A -1
   - calmodel = ~ A -1
   Are they equivalent?
# A7) Yes


8) Consider this specification:
   - calmodel = ~ A + x:A -1
   Is this calibration model factorizable? If yes, rephrase it in one equivalent
   partitioned form:
# A7) Yes it is
#     Partitioned formulation:
#     - calmodel  = ~ ones + x -1
#     - partition = ~ A


9) Calibrate simultaneously on:
   (i)  total number of elementary units within domains defined by A
   (ii) population total of z
# A9)
# - calmodel = ~ A + z -1


10) Calibrate on:
    (i)  total number of elementary units within domains defined by crossing A
         and B
    (ii) total number of elementary units within domains defined by C
# A10)
# - calmodel = ~ A:B + C -1


11) Calibrate simultaneously on:
    (i)   population total of x within domains defined by A
    (ii)  population total of x within domains defined by B
    (iii) population total of y within domains defined by crossing C and D
    (iv)  population total of z
    (v)   population total of u
	(vi)  total number of elementary units in the whole population
# A11)
# - calmodel = ~ x:(A + B) + y:C:D + z + u + ones -1


12) Calibrate (if possible in a partitioned way) simultaneously on:
    (i)   population total of x within domains defined by crossing A and B
    (ii)  total number of elementary units within domains defined by crossing B
          and C
# A12)
# - calmodel  = ~ x:A + C -1
# - partition = ~ B


13) Calibrate (if possible in a partitioned way) simultaneously on:
    (i)   total number of elementary units within domains defined by crossing A
          and B
    (ii)  population total of x within domains defined by crossing B and C
    (iii) population total of y within domains defined by crossing C and D
# A13) This is inherently global CANNOT be PARTITIONED.
#      Possible GLOBAL formulations:
# - calmodel  = ~ A:B + x:B:C + y:C:D -1
# - partition = FALSE
#
# - calmodel  = ~ (A + x:C):B + y:C:D -1
# - partition = FALSE
#
# - calmodel  = ~ A:B + (X:B + y:D):C -1
# - partition = FALSE


14) Calibrate (both in a global and in a partitioned way) simultaneously on:
    (i)   total number of elementary units within domains defined by crossing A
          and B
    (ii)  population total of x within domains defined by crossing A and B
    (iii) population total of y within domains defined by B
# A14)
# Global alternatives
# - calmodel = ~ A:B + x:A:B + y:B -1
#
# - calmodel = ~ (A + x:A + y):B -1
#
# - calmodel = ~ ((ones + x):A + y):B -1

# Partitioned alternatives
# - calmodel  = ~ A + x:A + y -1
# - partition = ~ B
#
# - calmodel  = ~ (ones + x):A + y -1
# - partition = ~ B
